pcl::ConditionalRemoval< PointT > Class Template Reference
Module filters

ConditionalRemoval filters data that satisfies certain conditions. More...

`#include <pcl/filters/conditional_removal.h>`

Inheritance diagram for pcl::ConditionalRemoval< PointT >:

## Public Types

typedef pcl::ConditionBase< PointT > | ConditionBase
typedef ConditionBase::Ptr | ConditionBasePtr
typedef ConditionBase::ConstPtr | ConditionBaseConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ConditionalRemoval (int extract_removed_indices=false)
| the default constructor. More...
| ConditionalRemoval (ConditionBasePtr condition, bool extract_removed_indices=false)
| a constructor that includes the condition. More...
void | setKeepOrganized (bool val)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
void | setUserFilterValue (float val)
| Provide a value that the filtered points should be set to instead of removing them. More...
void | setCondition (ConditionBasePtr condition)
| Set the condition that the filter will use. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Filter a Point Cloud. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

bool | capable_
| True if capable. More...
bool | keep_organized_
| Keep the structure of the data organized, by setting the filtered points to the a user given value (NaN by default). More...
ConditionBasePtr | condition_
| The condition to use for filtering. More...
float | user_filter_value_
| User given value to be set to any filtered point. More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::ConditionalRemoval< PointT >

ConditionalRemoval filters data that satisfies certain conditions.

A ConditionalRemoval must be provided a condition. There are two types of conditions: ConditionAnd and ConditionOr. Conditions require one or more comparisons and/or other conditions. A comparison has a name, a comparison operator, and a value.

An ConditionAnd will evaluate to true when ALL of its encapsulated comparisons and conditions are true.

An ConditionOr will evaluate to true when ANY of its encapsulated comparisons and conditions are true.

Depending on the derived type of the comparison, the name can correspond to a PointCloud field name, or a color component in rgb color space or hsi color space.

Here is an example usage: // Build the condition pcl::ConditionAnd<PointT>::Ptr range_cond (new pcl::ConditionAnd<PointT> ()); range_cond->addComparison (pcl::FieldComparison<PointT>::Ptr (new pcl::FieldComparison<PointT>("z", pcl::ComparisonOps::LT, 2.0))); range_cond->addComparison (pcl::FieldComparison<PointT>::Ptr (new pcl::FieldComparison<PointT>("z", pcl::ComparisonOps::GT, 0.0))); // Build the filter pcl::ConditionalRemoval<PointT> range_filt; range_filt.setCondition (range_cond); range_filt.setKeepOrganized (false);

Author
  Louis LeGrand, Intel Labs Seattle

Definition at line 594 of file conditional_removal.h.

## Member Typedef Documentation

template<typename PointT >

typedef pcl::ConditionBase<PointT> pcl::ConditionalRemoval< PointT >::ConditionBase

Definition at line 608 of file conditional_removal.h.

template<typename PointT >

typedef ConditionBase::ConstPtr pcl::ConditionalRemoval< PointT >::ConditionBaseConstPtr

Definition at line 610 of file conditional_removal.h.

template<typename PointT >

typedef ConditionBase::Ptr pcl::ConditionalRemoval< PointT >::ConditionBasePtr

Definition at line 609 of file conditional_removal.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::ConditionalRemoval< PointT >::ConditionalRemoval | ( | int | extract_removed_indices = `false` | ) |

inline

the default constructor.

All ConditionalRemovals require a condition which can be set using the setCondition method

Parameters

  extract_removed_indices | extract filtered indices from indices vector

Definition at line 618 of file conditional_removal.h.

template<typename PointT >

pcl::ConditionalRemoval< PointT >::ConditionalRemoval | ( | ConditionBasePtr | condition,
|  | bool | extract_removed_indices = `false`
| ) |  |

inline

a constructor that includes the condition.

Parameters

  condition | the condition that each point must satisfy to avoid being removed by the filter
  extract_removed_indices | extract filtered indices from indices vector

Definition at line 632 of file conditional_removal.h.

## Member Function Documentation

template<typename PointT >

void pcl::ConditionalRemoval< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Filter a Point Cloud.

Parameters

  output | the resultant point cloud message

Implements pcl::Filter< PointT >.

Definition at line 671 of file conditional_removal.hpp.

References pcl::ComparisonBase< PointT >::capable_, pcl::copyPoint(), pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

template<typename PointT >

bool pcl::ConditionalRemoval< PointT >::getKeepOrganized | ( |  | ) | const

inline

Definition at line 655 of file conditional_removal.h.

template<typename PointT >

void pcl::ConditionalRemoval< PointT >::setCondition | ( | ConditionBasePtr | condition | ) |

Set the condition that the filter will use.

Parameters

  condition | each point must satisfy this condition to avoid being removed by the filter

All ConditionalRemovals require a condition

Definition at line 663 of file conditional_removal.hpp.

References pcl::ComparisonBase< PointT >::capable_.

template<typename PointT >

void pcl::ConditionalRemoval< PointT >::setKeepOrganized | ( | bool | val | ) |

inline

Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.

By default, points are removed.

Parameters

  val | set to true whether the filtered points should be kept and set to a given user value (default: NaN)

Definition at line 649 of file conditional_removal.h.

template<typename PointT >

void pcl::ConditionalRemoval< PointT >::setUserFilterValue | ( | float | val | ) |

inline

Provide a value that the filtered points should be set to instead of removing them.

Used in conjunction with setKeepOrganized ().

Parameters

  val | the user given value that the filtered point dimensions should be set to

Definition at line 666 of file conditional_removal.h.

## Member Data Documentation

template<typename PointT >

bool pcl::ConditionalRemoval< PointT >::capable_

protected

True if capable.

Definition at line 688 of file conditional_removal.h.

template<typename PointT >

ConditionBasePtr pcl::ConditionalRemoval< PointT >::condition_

protected

The condition to use for filtering.

Definition at line 696 of file conditional_removal.h.

template<typename PointT >

bool pcl::ConditionalRemoval< PointT >::keep_organized_

protected

Keep the structure of the data organized, by setting the filtered points to the a user given value (NaN by default).

Definition at line 693 of file conditional_removal.h.

template<typename PointT >

float pcl::ConditionalRemoval< PointT >::user_filter_value_

protected

User given value to be set to any filtered point.

Casted to the correct field type.

Definition at line 701 of file conditional_removal.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/filters/include/pcl/filters/conditional_removal.h
- /build/pcl-6_P28C/pcl-1.7.2/filters/include/pcl/filters/impl/conditional_removal.hpp